---
product: "AG Grid"
title: "Active Overlay"
description: "Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component."
framework: javascript
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/overlays-overview/"
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/overlays-provided/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Active Overlay

Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component.

#### Active Overlay (Component Class)

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomOverlay, CustomParams } from "./customOverlay";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [
  { field: "athlete", flex: 1 },
  { field: "country", flex: 1 },
];

const rowData: IAthlete[] = [
  { athlete: "Michael Phelps", country: "United States" },
  { athlete: "Natalie Coughlin", country: "United States" },
  { athlete: "Aleksey Nemov", country: "Russia" },
  { athlete: "Alicia Coutts", country: "Australia" },
];

let gridApi: GridApi<IAthlete>;

const activeOverlayParams: CustomParams = {
  count: 1,
};

const gridOptions: GridOptions<IAthlete> = {
  columnDefs,
  rowData,
  activeOverlay: CustomOverlay,
  activeOverlayParams,
};

function showActiveOverlay() {
  gridApi.setGridOption("activeOverlay", CustomOverlay);
}

function clearActiveOverlay() {
  gridApi.setGridOption("activeOverlay", undefined);
}
function incParam() {
  activeOverlayParams.count++;
  gridApi.setGridOption("activeOverlayParams", activeOverlayParams);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).showActiveOverlay = showActiveOverlay;
  (<any>window).clearActiveOverlay = clearActiveOverlay;
  (<any>window).incParam = incParam;
}
```

[Live example: Active Overlay (Component Class)](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-component/typescript/)

## Display an Active Overlay

To display an overlay on demand set the `activeOverlay` / `activeOverlayParams` grid option. To clear the overlay set `activeOverlay = undefined`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `activeOverlay` | `any` |  |  |  |
| `activeOverlayParams` | `any` |  |  |  |

Implement the `IOverlayComp` interface to provide a custom overlay the grid will supply `IOverlayParams` whenever the component is created or refreshed.

```ts

interface IOverlayComp&lt;TData = any, TContext = any, TParams extends Readonly<<span/>IOverlayParams<<span/>TData, TContext>> = IOverlayParams<<span/>TData, TContext>&gt; {
  // Return the DOM element of your component, this is what the grid puts into the DOM 
  getGui(): <a tabindex="0" href="https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement" target="_blank" rel="noreferrer">HTMLElement</a>;

  // Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here 
  destroy?(): void;

  // The init(params) method is called on the component once. 
  init?(params: TParams): AgPromise<<span/>void>  |  void;

  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

The example below demonstrates using the grid provided overlays as an active overlay. Note the following:

- activeOverlays take precedence over the provided loading overlay.
- activeOverlay can be displayed no matter what the grid state, i.e showing the no-rows overlay even when there are rows.
- StatusOverlay is registered in the [components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/components/#2-by-name) map and shown by setting `activateOverlay = "statusOverlay"` to the key used.

#### Active Overlay Switcher

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { StatusOverlay } from "./statusOverlay";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef<IAthlete>[] = [
  { field: "athlete", flex: 1 },
  { field: "country", flex: 1 },
];

const rowData: IAthlete[] = [
  { athlete: "Michael Phelps", country: "United States" },
  { athlete: "Alicia Coutts", country: "Australia" },
];

let gridApi: GridApi<IAthlete>;
let statusOverlayCounter = 0;

const gridOptions: GridOptions<IAthlete> = {
  columnDefs,
  rowData,
  components: {
    statusOverlay: StatusOverlay,
  },
};

function showNoRowsOverlay() {
  gridApi.updateGridOptions({
    activeOverlay: "agNoRowsOverlay",
    activeOverlayParams: undefined,
  });
}

function showStatusOverlay() {
  gridApi.updateGridOptions({
    activeOverlay: "statusOverlay",
    activeOverlayParams: {
      myCounter: ++statusOverlayCounter,
    },
  });
}

function hideOverlay() {
  gridApi.updateGridOptions({
    activeOverlay: undefined,
    activeOverlayParams: undefined,
  });
}

function setLoading(isChecked: boolean) {
  gridApi.updateGridOptions({
    loading: isChecked ? true : undefined,
  });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

const loadingToggle =
  document.querySelector<HTMLInputElement>("#loading-toggle");
if (loadingToggle) {
  loadingToggle.addEventListener("change", () =>
    setLoading(loadingToggle.checked),
  );
  setLoading(loadingToggle.checked);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).showNoRowsOverlay = showNoRowsOverlay;
  (<any>window).showStatusOverlay = showStatusOverlay;
  (<any>window).hideOverlay = hideOverlay;
}
```

[Live example: Active Overlay Switcher](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-switcher/typescript/)


---
product: "AG Grid"
title: "Active Overlay"
description: "Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component."
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-overview/"
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/overlays-provided/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Active Overlay

Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component.

#### Active Overlay (Component Class)

```ts
import { Component, signal } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef, GridApi, GridReadyEvent } from "ag-grid-community";

import { CustomOverlayComponent } from "./custom-overlay.component";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="button-row">
      <button (click)="showActiveOverlay()">Show custom overlay</button>
      <button (click)="clearActiveOverlay()">Hide custom overlay</button>
      <button (click)="incParam()">Increment Param</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      class="grid-wrapper"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [activeOverlay]="activeOverlay()"
      [activeOverlayParams]="activeOverlayParams()"
    />
  </div>`,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", flex: 1 },
    { field: "country", flex: 1 },
  ];
  rowData: IAthlete[] | null = [
    { athlete: "Michael Phelps", country: "United States" },
    { athlete: "Natalie Coughlin", country: "United States" },
    { athlete: "Aleksey Nemov", country: "Russia" },
    { athlete: "Alicia Coutts", country: "Australia" },
  ];

  activeOverlay = signal<any>(CustomOverlayComponent);
  activeOverlayParams = signal({ count: 1 });

  showActiveOverlay() {
    this.activeOverlay.set(CustomOverlayComponent);
  }

  clearActiveOverlay() {
    this.activeOverlay.set(undefined);
  }
  incParam() {
    this.activeOverlayParams.update((prev) => ({ count: prev.count + 1 }));
  }
}
```

[Live example: Active Overlay (Component Class)](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-component/angular/)

## Display an Active Overlay

To display an overlay on demand set the `activeOverlay` / `activeOverlayParams` grid option. To clear the overlay set `activeOverlay = undefined`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `activeOverlay` | `any` |  |  |  |
| `activeOverlayParams` | `any` |  |  |  |

Implement the `IOverlayComp` interface to provide a custom overlay the grid will supply `IOverlayParams` whenever the component is created or refreshed.

```ts

interface IOverlayAngularComp {
  // Mandatory - Params for rendering this component. 
  agInit(params: IOverlayParams): void;

  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

The example below demonstrates using the grid provided overlays as an active overlay. Note the following:

- activeOverlays take precedence over the provided loading overlay.
- activeOverlay can be displayed no matter what the grid state, i.e showing the no-rows overlay even when there are rows.
- StatusOverlay is registered in the [components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/components/#2-by-name) map and shown by setting `activateOverlay = "statusOverlay"` to the key used.

#### Active Overlay Switcher

```ts
import { Component, computed, model, signal } from "@angular/core";
import { FormsModule } from "@angular/forms";

import { AgGridAngular } from "ag-grid-angular";
import type { IOverlayAngularComp } from "ag-grid-angular";
import type { ColDef } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import type { IOverlayParams } from "ag-grid-community";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

@Component({
  standalone: true,
  template: `<div class="status-overlay">Custom</div>`,
})
export class StatusOverlayComponent implements IOverlayAngularComp {
  agInit(params: IOverlayParams): void {
    console.log("init");
  }
}

interface Athlete {
  athlete: string;
  country: string;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, FormsModule],
  template: `<div class="example-wrapper">
    <div class="button-row">
      <label class="toggle loading-toggle"
        ><input
          type="checkbox"
          [checked]="loadingToggle()"
          (change)="loadingToggle.set(!loadingToggle())"
        />
        Loading</label
      >
      <button type="button" (click)="showNoRowsOverlay()">
        activeOverlay = agNoRowsOverlay
      </button>
      <button type="button" (click)="showCustomOverlay()">
        activeOverlay = CustomOverlay
      </button>
      <button type="button" (click)="clearOverlay()">Hide activeOverlay</button>
    </div>
    <div class="grid-wrapper">
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [rowData]="rowData"
        [components]="components"
        [loading]="loading()"
        [activeOverlay]="activeOverlay()"
      />
    </div>
  </div>`,
})
export class AppComponent {
  public readonly columnDefs: ColDef<Athlete>[] = [
    { field: "athlete", flex: 1 },
    { field: "country", flex: 1 },
  ];

  public readonly rowData: Athlete[] = [
    { athlete: "Michael Phelps", country: "United States" },
    { athlete: "Natalie Coughlin", country: "United States" },
  ];

  public readonly components = { statusOverlay: StatusOverlayComponent };

  public readonly activeOverlay = signal<string | undefined>(undefined);
  public readonly loadingToggle = signal<boolean>(false);
  public readonly loading = computed(() => this.loadingToggle());

  public showNoRowsOverlay(): void {
    this.activeOverlay.set("agNoRowsOverlay");
  }

  public showCustomOverlay(): void {
    this.activeOverlay.set("statusOverlay");
  }

  public clearOverlay(): void {
    this.activeOverlay.set(undefined);
  }
}
```

[Live example: Active Overlay Switcher](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-switcher/angular/)


---
product: "AG Grid"
title: "Active Overlay"
description: "Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component."
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-overview/"
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/overlays-provided/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Active Overlay

Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component.

#### Active Overlay (Component Class)

```ts
import { createApp, defineComponent, ref, shallowRef } from "vue";

import type { ColDef, GridApi, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import { CustomOverlay } from "./customOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface IAthlete {
  athlete: string;
  country: string;
}

const VueExample = defineComponent({
  template: `<div class="example-wrapper">
            <div class="button-row">
                <button v-on:click="showActiveOverlay()">Show custom overlay</button>
                <button v-on:click="clearActiveOverlay()">Hide custom overlay</button>
                <button v-on:click="incrementParam()">Increment Param</button>
            </div>
            <ag-grid-vue
                class="grid-wrapper"
                :columnDefs="columnDefs"
                :rowData="rowData"
                :activeOverlay="activeOverlay"
                :activeOverlayParams="activeOverlayParams"
            />
        </div>`,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", flex: 1 },
      { field: "country", flex: 1 },
    ]);
    const rowData = ref<IAthlete[] | null>([
      { athlete: "Michael Phelps", country: "United States" },
      { athlete: "Natalie Coughlin", country: "United States" },
      { athlete: "Aleksey Nemov", country: "Russia" },
      { athlete: "Alicia Coutts", country: "Australia" },
    ]);
    const activeOverlay = shallowRef<any>(CustomOverlay);
    const activeOverlayParams = ref<{ count: number }>({ count: 1 });

    function showActiveOverlay() {
      activeOverlay.value = CustomOverlay;
    }
    function clearActiveOverlay() {
      activeOverlay.value = undefined;
    }
    function incrementParam() {
      activeOverlayParams.value.count++;
    }

    return {
      columnDefs,
      rowData,
      activeOverlay,
      activeOverlayParams,
      showActiveOverlay,
      clearActiveOverlay,
      incrementParam,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Active Overlay (Component Class)](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-component/vue3/)

## Display an Active Overlay

To display an overlay on demand set the `activeOverlay` / `activeOverlayParams` grid option. To clear the overlay set `activeOverlay = undefined`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `activeOverlay` | `any` |  |  |  |
| `activeOverlayParams` | `any` |  |  |  |

Any valid Vue component can be used, however the optional `IOverlay` interface exposes lifecycle hooks that receive `IOverlayParams`.

```ts

interface IOverlay&lt;TData = any, TContext = any, TParams extends Readonly<<span/>IOverlayParams<<span/>TData, TContext>> = IOverlayParams<<span/>TData, TContext>&gt; {
  // Gets called when the `overlayComponentParams` grid option is updated
  refresh?(params: TParams): void;

}
```

The example below demonstrates using the grid provided overlays as an active overlay. Note the following:

- activeOverlays take precedence over the provided loading overlay.
- activeOverlay can be displayed no matter what the grid state, i.e showing the no-rows overlay even when there are rows.
- StatusOverlay is registered in the [components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/components/#registering-custom-components) map and shown by setting `activateOverlay = "statusOverlay"` to the key used.

#### Active Overlay Switcher

```ts
import { createApp, defineComponent, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

import { StatusOverlay } from "./statusOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

interface Athlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef<Athlete>[] = [
  { field: "athlete", flex: 1 },
  { field: "country", flex: 1 },
];

const rowData: Athlete[] = [
  { athlete: "Michael Phelps", country: "United States" },
  { athlete: "Alicia Coutts", country: "Australia" },
];

const VueExample = defineComponent({
  components: {
    "ag-grid-vue": AgGridVue,
  },
  template: `
        <div class="example-wrapper">
            <div class="button-row">
                <label class="toggle loading-toggle">
                    <input type="checkbox" :checked="loading === true" @change="onLoadingToggle" /> Loading
                </label>
                <button type="button" @click="showNoRowsOverlay">activeOverlay = agNoRowsOverlay</button>
                <button type="button" @click="showCustomOverlay">activeOverlay = CustomOverlay</button>
                <button type="button" @click="clearOverlay">Hide activeOverlay</button>
            </div>
            <ag-grid-vue
                class="grid-wrapper"
                :columnDefs="columnDefs"
                :rowData="rowData"
                :components="components"
                :loading="loading"
                :activeOverlay="activeOverlay"
            />
        </div>
    `,
  setup() {
    const activeOverlay = ref<string | undefined>();
    const loading = ref<boolean | undefined>(undefined);
    const components = { statusOverlay: StatusOverlay };

    const showNoRowsOverlay = () => {
      activeOverlay.value = "agNoRowsOverlay";
    };

    const showCustomOverlay = () => {
      activeOverlay.value = "statusOverlay";
    };

    const clearOverlay = () => {
      activeOverlay.value = undefined;
    };

    const onLoadingToggle = (event: Event) => {
      const checked = (event.target as HTMLInputElement).checked;
      loading.value = checked ? true : undefined;
    };

    return {
      columnDefs,
      rowData,
      components,
      activeOverlay,
      loading,
      onLoadingToggle,
      showNoRowsOverlay,
      showCustomOverlay,
      clearOverlay,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Active Overlay Switcher](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-switcher/vue3/)


---
product: "AG Grid"
title: "Active Overlay"
description: "Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component."
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-overview/"
    - title: "Provided Overlays"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/overlays-provided/"
    - title: "Loading Rows"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/loading-rows/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Active Overlay

Applications can display an overlay on demand regardless of grid state. This is achieved by providing an active overlay which can be one of the provided overlays or be a custom overlay component.

#### Active Overlay (Component Class)

```tsx
'use client';
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import type { CustomParams } from "./customOverlay";
import { CustomOverlay } from "./customOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [
  { field: "athlete", flex: 1 },
  { field: "country", flex: 1 },
];

const rowData: IAthlete[] = [
  { athlete: "Michael Phelps", country: "United States" },
  { athlete: "Natalie Coughlin", country: "United States" },
  { athlete: "Aleksey Nemov", country: "Russia" },
  { athlete: "Alicia Coutts", country: "Australia" },
];

const GridExample = () => {
  const [activeOverlay, setActiveOverlay] = useState<any>(() => CustomOverlay);
  const [activeOverlayParams, setActiveOverlayParams] = useState<CustomParams>({
    count: 1,
  });

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div className="button-row">
          <button onClick={() => setActiveOverlay(() => CustomOverlay)}>
            Show custom overlay
          </button>
          <button onClick={() => setActiveOverlay(undefined)}>
            Hide custom overlay
          </button>
          <button
            onClick={() =>
              setActiveOverlayParams((prev) => ({ count: prev.count + 1 }))
            }
          >
            Increment Param
          </button>
        </div>

        <div className="grid-wrapper">
          <AgGridReact<IAthlete>
            rowData={rowData}
            columnDefs={columnDefs}
            activeOverlay={activeOverlay}
            activeOverlayParams={activeOverlayParams}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Active Overlay (Component Class)](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-component/reactFunctionalTs/)

## Display an Active Overlay

To display an overlay on demand set the `activeOverlay` / `activeOverlayParams` grid option. To clear the overlay set `activeOverlay = undefined`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `activeOverlay` | `any` |  |  |  |
| `activeOverlayParams` | `any` |  |  |  |

The example below demonstrates using the grid provided overlays as an active overlay. Note the following:

- activeOverlays take precedence over the provided loading overlay.
- activeOverlay can be displayed no matter what the grid state, i.e showing the no-rows overlay even when there are rows.
- StatusOverlay is registered in the [components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/components/#2-by-name) map and shown by setting `activateOverlay = "statusOverlay"` to the key used.

#### Active Overlay Switcher

```tsx
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import StatusOverlay from "./statusOverlay";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

interface IAthlete {
  athlete: string;
  country: string;
}

const columnDefs: ColDef[] = [
  { field: "athlete", flex: 1 },
  { field: "country", flex: 1 },
];

const rowData: IAthlete[] = [
  { athlete: "Michael Phelps", country: "United States" },
  { athlete: "Natalie Coughlin", country: "United States" },
];

const GridExample = () => {
  const components = useMemo(() => ({ statusOverlay: StatusOverlay }), []);
  const [activeOverlay, setActiveOverlay] = useState<string | undefined>();
  const [loading, setLoading] = useState<boolean | undefined>(undefined);

  const setNoRowsOverlay = () => {
    setActiveOverlay("agNoRowsOverlay");
  };

  const setCustomOverlay = () => {
    setActiveOverlay("statusOverlay");
  };

  const clearOverlay = () => {
    setActiveOverlay(undefined);
  };

  const onLoadingToggle = (event: React.ChangeEvent<HTMLInputElement>) => {
    setLoading(event.target.checked ? true : undefined);
  };

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div className="button-row">
          <label className="toggle loading-toggle">
            <input
              type="checkbox"
              checked={loading === true}
              onChange={onLoadingToggle}
            />{" "}
            Loading
          </label>
          <button onClick={setNoRowsOverlay}>
            activeOverlay = agNoRowsOverlay
          </button>
          <button onClick={setCustomOverlay}>
            activeOverlay = CustomOverlay
          </button>
          <button onClick={clearOverlay}>Hide activeOverlay</button>
        </div>

        <div className="grid-wrapper">
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            components={components}
            loading={loading}
            activeOverlay={activeOverlay}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Active Overlay Switcher](https://www.ag-grid.com/archive/36.2.0/examples/overlays-active/active-overlay-switcher/reactFunctionalTs/)
